diff --git a/packages/visualgst/Gtk/GtkTreeModel.st b/packages/visualgst/Gtk/GtkTreeModel.st
new file mode 100644
index 0000000..7734f09
--- /dev/null
+++ b/packages/visualgst/Gtk/GtkTreeModel.st
@@ -0,0 +1,176 @@
+"======================================================================
+|
+| GtkTreeModel class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Object subclass: GtkTreeModel [
+
+    GtkTreeModel class >> on: aGtkTreeStore [
+	<category: 'instance creation'>
+
+	^ super new
+	    initialize;
+	    gtkModel: aGtkTreeStore;
+	    yourself
+    ]
+
+    | childrenBlock contentsBlock item model |
+
+    initialize [
+	<category: 'initialization'>
+
+    ]
+
+    gtkModel: aGtkTreeStore [
+	<category: 'accessing'>
+
+	model := aGtkTreeStore
+    ]
+
+    connectSignal: aString to: anObject selector: aSymbol [
+	<category: 'events'>
+
+	^ model connectSignal: aString to: anObject selector: aSymbol
+    ]
+
+    item: anObject [
+	<category: 'accessing'>
+
+	item := anObject
+    ]
+
+    item [
+	<category: 'accessing'>
+
+	^ item
+    ]
+
+    childrenBlock: aBlock [
+	<category: 'accessing'>
+
+	childrenBlock := aBlock
+    ]
+
+    childrenBlock [
+	<category: 'accessing'>
+
+	^ childrenBlock
+    ]
+
+    contentsBlock: aBlock [
+	<category: 'accessing'>
+
+	contentsBlock := aBlock
+    ]
+
+    contentsBlock [
+	<category: 'accessing'>
+
+	^ contentsBlock
+    ]
+
+    append: anObject [
+        <category:' model'>
+
+        self append: anObject with: nil
+    ]
+
+    append: anObject parent: aParentObject [
+	<category:' model'>
+
+	self append: anObject with: (self findIter: aParentObject)
+    ]
+
+    append: anItem with: aParentIter [
+        <category:' model'>
+
+        | iter |
+        iter := model append: aParentIter item: ((self contentsBlock value: anItem) copyWith: anItem).
+        (self childrenBlock value: anItem) do: [ :each | self append: each with: iter ]
+    ]
+
+    remove: anObject ifAbsent: aBlock [
+	<category: 'model'>
+
+        | iter |
+        iter := self findIter: anObject ifAbsent: [ ^ aBlock value ].
+        model remove: iter
+    ]
+
+    remove: anObject [
+	<category: 'model'>
+
+	self remove: anObject ifAbsent: [ self error: 'item not found' ]
+    ]
+
+    clear [
+	<category: 'model'>
+
+	model clear
+    ]
+
+    refresh [
+	<category: 'model'>
+
+	self clear.
+	self item ifNil: [ ^ self ].
+	(self childrenBlock value: self item) do: [ :each | self append: each with: nil ]
+    ]
+
+    hasItem: anObject [
+        <category: 'item selection'>
+
+        self findIter: anObject ifAbsent: [ ^ false ].
+        ^ true
+    ]
+
+    findIter: anObject ifAbsent: aBlock [
+	<category: 'item selection'>
+
+	model do: [ :elem :iter |
+	    elem last = anObject ifTrue: [ ^ iter ] ].
+	aBlock value
+    ]
+
+    findIter: anObject [
+	<category: 'item selection'>
+
+	^ self findIter: anObject ifAbsent: [ self error: 'Item not found' ]
+    ]
+
+    includes: anObject [
+	self findIter: anObject ifAbsent: [ ^ false ].
+	^ true
+    ]
+]
+
diff --git a/packages/visualgst/GtkConcreteWidget.st b/packages/visualgst/GtkConcreteWidget.st
index 26973ec..4a54d29 100644
--- a/packages/visualgst/GtkConcreteWidget.st
+++ b/packages/visualgst/GtkConcreteWidget.st
@@ -34,7 +34,8 @@
 ======================================================================"
 
 Object subclass: GtkConcreteWidget [
-    | child parentWindow popupMenu |
+
+    | child parent parentWindow popupMenu |
 
     GtkConcreteWidget class >> parentWindow: aGtkWindow [
 	<category: 'instance creation'>
@@ -59,6 +60,18 @@ Object subclass: GtkConcreteWidget [
 
     ]
 
+    parent: aWidget [
+        <category: 'accessing'>
+
+        parent := aWidget
+    ]
+
+    parent [
+        <category: 'accessing'>
+
+        ^ parent
+    ]
+
     parentWindow: aGtkWindow [
         <category: 'accessing'>
 
diff --git a/packages/visualgst/GtkEntryDialog.st b/packages/visualgst/GtkEntryDialog.st
index c4f1d6d..60c2079 100644
--- a/packages/visualgst/GtkEntryDialog.st
+++ b/packages/visualgst/GtkEntryDialog.st
@@ -74,7 +74,7 @@ Object subclass: GtkEntryDialog [
     result [
 	<category: 'accessing'>
 
-	^ entryWidget getText
+	^ entryWidget text
     ]
 
     buildCentralWidget: aString on: aGtkDialog [
@@ -88,12 +88,12 @@ Object subclass: GtkEntryDialog [
         defaultButton := GTK.Gtk perform: buttons first second.
         aGtkDialog setDefaultResponse: defaultButton.
 	hbox := GTK.GtkHBox new: true spacing: 0.
-	labelWidget := GTK.GtkLabel new: aString.
-	entryWidget := GTK.GtkEntry new.
+	labelWidget := Label text: aString.
+	entryWidget := Entry new.
         entryWidget setActivatesDefault: true.
 	hbox
-	    add: labelWidget;
-	    add: entryWidget;
+	    add: labelWidget mainWidget;
+	    add: entryWidget mainWidget;
 	    showAll.
 	aGtkDialog getVBox add: hbox
     ]
diff --git a/packages/visualgst/GtkEntryWidget.st b/packages/visualgst/GtkEntryWidget.st
index 4b21e3a..ed2fc4f 100644
--- a/packages/visualgst/GtkEntryWidget.st
+++ b/packages/visualgst/GtkEntryWidget.st
@@ -57,7 +57,7 @@ GtkConcreteWidget subclass: GtkEntryWidget [
 
         entry := GTK.GtkEntry new.
         ^ (GTK.GtkHBox new: true spacing: 3)
-			add: (GTK.GtkLabel new: label);
+			add: (Label text: label) mainWidget;
 			add: entry;
 			yourself
     ]
diff --git a/packages/visualgst/GtkHistoryWidget.st b/packages/visualgst/GtkHistoryWidget.st
index 106f1f4..0a297e4 100644
--- a/packages/visualgst/GtkHistoryWidget.st
+++ b/packages/visualgst/GtkHistoryWidget.st
@@ -33,21 +33,14 @@
 |
 ======================================================================"
 
-GtkConcreteWidget subclass: GtkHistoryWidget [
-    | browser model widget |
+Compoment subclass: GtkHistoryWidget [
 
-    GtkHistoryWidget class >> new [
-	<category: 'instance creation'>
-
-	^ super new
-		initialize;
-		yourself
-    ]
+    | browser stack |
 
     initialize [
 	<category: 'initialization'>
 
-	self mainWidget: self buildListView
+        self buildListView.
     ]
 
     browser: aBrowser [
@@ -59,40 +52,22 @@ GtkConcreteWidget subclass: GtkHistoryWidget [
     buildListView [
 	<category: 'user interface'>
 
-        widget := (GTK.GtkTreeView createListWithModel: {{GtkColumnTextType title: 'History'}})
-                            connectSignal: 'button-press-event' to: self selector: #'onPress:event:';
-                            yourself.
-        widget getSelection setMode: GTK.Gtk gtkSelectionBrowse.
-        widget getSelection connectSignal: 'changed' to: self selector: #onSelectionChanged.
-        (model := GtkListModel on: widget getModel)
-                                        contentsBlock: [ :each | {each name displayString} ].
-        ^ GTK.GtkScrolledWindow withChild: widget
+        self widget: (List column: {{GtkColumnTextType title: 'History'}} contents: [ :each | {each name displayString} ]).
+        widget popupMenu: (HistorySelectionMenus on: self) "{{'Inspect a class'. self. #inspectClass}.
+                           {'Open in new tab'. self. #browseTabbedClass}.
+                          {'Open in new window'. self. #browseClass}}".
+        widget singleSelection.
+        widget whenSelectionChangedSend: #onSelectionChanged to: self.
     ]
 
     refresh: historyStack [
 	<category: 'user interface'>
 
-	model
-	    item: historyStack;
+	widget
+	    item: (stack := historyStack);
 	    refresh.
 
-        widget selectNth: historyStack selectedIndex.
-    ]
-
-    onPress: aGtkWidget event: aGdkEvent [
-        <category: 'button event'>
-
-        | menu aGdkButtonEvent |
-        aGdkButtonEvent := aGdkEvent castTo: GTK.GdkEventButton type.
-        aGdkButtonEvent button value = 3 ifFalse: [ ^ false ].
-        menu := GTK.GtkMenu new.
-        menu appendMenuItems: {{'Inspect a class'. self. #inspectClass}.
-            {'Open in new tab'. self. #browseTabbedClass}.
-            "{'Open in new window'. self. #browseClass}"}.
-        menu attachToWidget: widget detacher: nil.
-        menu popup: nil parentMenuItem: nil func: nil data: nil button: 3 activateTime: aGdkButtonEvent time value.
-        menu showAll.
-        ^ true
+        widget selectAt: historyStack selectedIndex.
     ]
 
     targetObject [
@@ -125,9 +100,9 @@ GtkConcreteWidget subclass: GtkHistoryWidget [
     onSelectionChanged [
 	<category: 'event'>
 
-	widget hasSelectedItem ifFalse: [ ^ self ].
-        model item selectedIndex = widget selectedIndex ifTrue: [^self].
-        model item selectItem: widget selectedIndex.
+	widget hasSelection ifFalse: [ ^ self ].
+        stack selectedIndex = widget selectionIndex ifTrue: [^self].
+        stack selectItem: widget selectionIndex.
     ]
 
     browseTabbedClass [
@@ -135,14 +110,14 @@ GtkConcreteWidget subclass: GtkHistoryWidget [
 
         "TODO: should reuse OpenTabbedBrowserCommand by giving a state to
          GtkHistoryWidget."
-	widget hasSelectedItem ifFalse: [ ^ self ].
+	widget hasSelection ifFalse: [ ^ self ].
         self updateBrowser: GtkLauncher uniqueInstance classBrowser
     ]
 
     state [
         <category: 'state'>
 
-        ^model item current
+        ^ stack current
     ]
 ]
 
diff --git a/packages/visualgst/GtkLauncher.st b/packages/visualgst/GtkLauncher.st
index 5383b34..2ae1bf0 100644
--- a/packages/visualgst/GtkLauncher.st
+++ b/packages/visualgst/GtkLauncher.st
@@ -36,7 +36,7 @@
 GtkVisualGSTTool subclass: GtkLauncher [
     GtkLauncher class [ | uniqueInstance | ]
 
-    | leftSidebar rightSidebar topSidebar packageBuilderWidget implementorResultWidget senderResultWidget senderWidget implementorWidget historyWidget browsers outputs saved imageName transcriptWidget windowsMenu systemChangeNotifier |
+    | leftSidebarP leftSidebar rightSidebar topSidebarP topSidebar packageBuilderWidget implementorResultWidget senderResultWidget senderWidget implementorWidget historyWidget browsers outputs saved imageName transcriptWidget windowsMenu systemChangeNotifier |
 
     GtkLauncher class >> uniqueInstance [
 	<category: 'public'>
@@ -130,7 +130,7 @@ GtkVisualGSTTool subclass: GtkLauncher [
 	<category: 'tools events'>
 
 	| widget |
-	browsers addWidget: (widget := self buildClassBrowserWidget) labeled: 'Browser'.
+	browsers addWidget: (widget := self buildClassBrowserWidget) label: 'Browser'.
         browsers showLastPage.
 	widget postInitialize.
 	^ widget
@@ -146,9 +146,9 @@ GtkVisualGSTTool subclass: GtkLauncher [
 	<category: 'tools events'>
 
 	| widget |
-	widget := self buildWorkspaceWidget showAll.
+	widget := self buildWorkspaceWidget.
 	widget postInitialize.
-	outputs addWidget: widget labeled: aString.
+	outputs addWidget: widget label: aString.
         outputs showLastPage.
         ^widget
     ]
@@ -310,10 +310,10 @@ GtkVisualGSTTool subclass: GtkLauncher [
     subscribe [
 	<category: 'initialization'>
 
-	GtkAnnouncer current on: GtkNamespaceSelectionChanged do: [ :ann |
+	"GtkAnnouncer current on: GtkNamespaceSelectionChanged do: [ :ann |
 	    browsers updateWidget: browsers currentWidget withLabel: ann selectedNamespace name asString].
 	GtkAnnouncer current on: GtkClassSelectionChanged do: [ :ann |
-	    browsers updateWidget: browsers currentWidget withLabel: ann selectedClass printString]
+	    browsers updateWidget: browsers currentWidget withLabel: ann selectedClass printString]"
     ]
 
     windowTitle [
@@ -338,26 +338,21 @@ GtkVisualGSTTool subclass: GtkLauncher [
 	super postInitialize.
         self browserPostInitialize.
 	1 to: 2 do: [ :i | (outputs widgetAt: i) postInitialize ].
-	leftSidebar mainWidget getParent setPosition: 270.
-	topSidebar mainWidget getParent setPosition: 100.
-	leftSidebar postInitialize.
-	topSidebar postInitialize.
-	rightSidebar postInitialize.
-	window
-	    connectSignal: 'key-press-event' to: self selector:  #'keyPressedOn:keyEvent:'
+	self hideSidebars.
+        leftSidebarP position: 150.
+        topSidebarP position: 100.
+	window connectSignal: 'key-press-event' to: self selector:  #'keyPressedOn:keyEvent:'
     ]
 
     buildNotebookWorkspaceWidget [
 	<category: 'user interface'>
 
-	outputs := GtkNotebookWidget new
-				initialize;
+	outputs := Notebook new
 				parentWindow: window;
-				showAll;
 				yourself.
 	^ outputs
-	    addPermanentWidget: (transcriptWidget := self buildTranscriptWidget) labeled: 'Transcript';
-	    addWidget: self buildWorkspaceWidget labeled: 'Workspace';
+	    addPermanentWidget: (transcriptWidget := self buildTranscriptWidget) label: 'Transcript';
+	    addWidget: self buildWorkspaceWidget label: 'Workspace';
 	    yourself
     ]
 
@@ -370,81 +365,71 @@ GtkVisualGSTTool subclass: GtkLauncher [
     buildImplementorPaned [
        <category: 'user interface'>
 
-	leftSidebar := GtkHSidebarWidget new
-			    initialize;
+	leftSidebar := HSidebar new
 			    addAll: {self buildImplementorView -> 'Implementor'. self buildSenderView -> 'Sender'. self buildHistoryView -> 'History'};
 			    yourself.
 	self registerLeftPaneEvents.
-	^ leftSidebar mainWidget
+	^ leftSidebar
     ]
 
     buildPackageBuilderView [
 	<category: 'user interface'>
 
-	packageBuilderWidget := GtkPackageBuilderWidget new
+	^ packageBuilderWidget := GtkPackageBuilderWidget new
 						    initialize;
 						    yourself.
-	^ packageBuilderWidget mainWidget
     ]
 
     buildRightSidebarPaned [
        <category: 'user interface'>
 
-        rightSidebar := GtkHSidebarWidget new
-                            initialize;
+        ^ rightSidebar := HSidebar new
                             addAll: {self buildPackageBuilderView -> 'Package Builder'};
                             yourself.
-        ^ rightSidebar mainWidget
     ]
 
     buildBrowserAndWorkspaceWidget [
         <category: 'intialize-release'>
 
-        ^ GTK.GtkVPaned addAll: {
-		    GTK.GtkHPaned addAll: {self buildImplementorPaned. self buildBottomPanedAndClassBrowser. self buildRightSidebarPaned}. 
-		    self buildNotebookWorkspaceWidget mainWidget}
+        ^ VPaned addAll:
+		    { leftSidebarP := HPaned addAll: { self buildImplementorPaned. self buildBottomPanedAndClassBrowser. self buildRightSidebarPaned }. 
+		      self buildNotebookWorkspaceWidget }
     ]
 
     buildImplementorView [
        <category: 'user interface'>
 
-        implementorWidget := self buildImageView
+        ^ implementorWidget := self buildImageView
 			    whenSelectionChangedSend: #implementorSelected to: self;
 			    yourself.
-        ^ implementorWidget mainWidget
     ]
 
     buildSenderView [
        <category: 'user interface'>
 
-        senderWidget := self buildImageView
+        ^ senderWidget := self buildImageView
 			    whenSelectionChangedSend: #senderSelected to: self;
 			    yourself.
-        ^ senderWidget mainWidget
     ]
 
     buildImageView [
        <category: 'user interface'>
 
         ^ GtkImageWidget new
-			initialize;
-                        yourself
     ]
 
     buildHistoryView [
        <category: 'user interface'>
 
-        historyWidget := GtkHistoryWidget new
+        ^ historyWidget := GtkHistoryWidget new
                                     browser: self;
                                     yourself.
-        ^ historyWidget mainWidget
     ]
 
     buildImplementorResultList [
         <category: 'user interface'>
 
         ^ implementorResultWidget := GtkImplementorResultsWidget new
-					    initialize;
 					    whenSelectionChangedSend: #resultImplementorSelected to: self;
 					    yourself
     ]
@@ -453,7 +438,6 @@ GtkVisualGSTTool subclass: GtkLauncher [
         <category: 'user interface'>
 
         ^ senderResultWidget := GtkSenderResultsWidget new
-					    initialize;
 					    whenSelectionChangedSend: #resultSenderSelected to: self;
 					    yourself
     ]
@@ -461,27 +445,24 @@ GtkVisualGSTTool subclass: GtkLauncher [
     buildTopSidebar [
         <category: 'user interface'>
 
-        topSidebar := GtkHSidebarWidget new
-                            initialize;
-                            addAll: {self buildImplementorResultList mainWidget -> ''. self buildSenderResultList mainWidget -> ''};
+        ^ topSidebar := HSidebar new
+                            addAll: {self buildImplementorResultList -> ''. self buildSenderResultList -> ''};
 			    hideTabs;
                             yourself.
-        ^ topSidebar mainWidget
     ]
 
     buildBottomPanedAndClassBrowser [
         <category: 'user interface'>
 
-	^ GTK.GtkVPaned addAll: {self buildTopSidebar. self buildClassBrowserTabbedWidget mainWidget}
+	^ topSidebarP := VPaned addAll: {self buildTopSidebar. self buildClassBrowserTabbedWidget}
     ]
 
     buildClassBrowserTabbedWidget [
 	<category: 'user interface'>
 
-	^ (browsers := GtkNotebookWidget parentWindow: window)
-				    showAll;
+	^ (browsers := Notebook parentWindow: window)
                                     whenSelectionChangedSend: #historyChanged to: self;
-				    addWidget: self buildClassBrowserWidget labeled: 'Browser';
+				    addWidget: self buildClassBrowserWidget label: 'Browser';
 				    yourself
     ]
 
@@ -509,9 +490,9 @@ GtkVisualGSTTool subclass: GtkLauncher [
 	<category: 'user interface'>
 
 	leftSidebar 
-	    whenWidgetIsVisible: implementorWidget mainWidget send: #switchToImplementor to: self;
-	    whenWidgetIsVisible: senderWidget mainWidget send: #switchToSender to: self;
-	    whenWidgetIsVisible: historyWidget mainWidget send: #switchToHistory to: self.
+	    whenWidgetIsVisible: implementorWidget send: #switchToImplementor to: self;
+	    whenWidgetIsVisible: senderWidget send: #switchToSender to: self;
+	    whenWidgetIsVisible: historyWidget send: #switchToHistory to: self.
     ]
 
     createEditMenus [
@@ -818,8 +799,8 @@ GtkVisualGSTTool subclass: GtkLauncher [
 
         | isVisible |
         isVisible := aGtkWidget isVisible.
-	leftSidebar mainWidget getParent getPosition = 0 ifTrue: [ isVisible := false. leftSidebar mainWidget getParent setPosition: 270 ].
-	topSidebar mainWidget getParent getPosition = 0 ifTrue: [ isVisible := false. topSidebar mainWidget getParent setPosition: 100 ].
+	leftSidebarP position = 0 ifTrue: [ isVisible := false. leftSidebarP position: 150 ].
+	topSidebarP position = 0 ifTrue: [ isVisible := false. topSidebarP position: 100 ].
 	self hideSidebars.
         isVisible
             ifFalse: [
diff --git a/packages/visualgst/GtkTranscriptWidget.st b/packages/visualgst/GtkTranscriptWidget.st
index d724e07..65a308b 100644
--- a/packages/visualgst/GtkTranscriptWidget.st
+++ b/packages/visualgst/GtkTranscriptWidget.st
@@ -38,7 +38,7 @@ GtkWorkspaceWidget subclass: GtkTranscriptWidget [
     initialize [
 	<category: 'initialization'>
 
-	Transcript message: self->#update:.
+	"Transcript message: self->#update:."
 	super initialize
     ]
 
diff --git a/packages/visualgst/GtkVariableTrackerWidget.st b/packages/visualgst/GtkVariableTrackerWidget.st
index 52e8642..6b295fe 100644
--- a/packages/visualgst/GtkVariableTrackerWidget.st
+++ b/packages/visualgst/GtkVariableTrackerWidget.st
@@ -33,14 +33,14 @@
 |
 ======================================================================"
 
-GtkConcreteWidget subclass: GtkVariableTrackerWidget [
-    | model object widget |
+Compoment subclass: GtkVariableTrackerWidget [
+
+    | object |
 
     GtkVariableTrackerWidget class >> on: anObject [
 	<category: 'instance creation'>
 
 	^ self new
-		initialize;
 		object: anObject;
 		yourself
     ]
@@ -48,7 +48,7 @@ GtkConcreteWidget subclass: GtkVariableTrackerWidget [
     initialize [
 	<category: 'initialization'>
 
-	self mainWidget: self buildListView
+	self buildListView.
     ]
 
     object: anObject [
@@ -61,18 +61,15 @@ GtkConcreteWidget subclass: GtkVariableTrackerWidget [
     buildListView [
 	<category: 'user interface'>
 
-        widget := GtkScrollTreeWidget createListWithModel: {{GtkColumnTextType title: 'Variable'}. {GtkColumnTextType title: 'Value'}}.
-        widget connectToWhenPopupMenu: (WorkspaceVariableMenus on: self).
-        widget treeView getSelection setMode: GTK.Gtk gtkSelectionBrowse.
-        (model := GtkListModel on: widget treeView getModel)
-                                        contentsBlock: [ :each | {each asString. (object instVarNamed: each) displayString} ].
-        ^ widget mainWidget
+        self widget: (List column: {{GtkColumnTextType title: 'Variable'}. {GtkColumnTextType title: 'Value'}} contents: [ :each | {each asString. (object instVarNamed: each) displayString} ]).
+        widget popupMenu: (WorkspaceVariableMenus on: self).
+        widget singleSelection.
     ]
 
     refresh [
 	<category: 'user interface'>
 
-	model
+	widget
 	    item: object class allInstVarNames;
 	    refresh
     ]
@@ -83,16 +80,16 @@ GtkConcreteWidget subclass: GtkVariableTrackerWidget [
         ^ object instVarNamed: self selectedValue
     ]
 
-    hasSelectedValue [
+    hasSelection [
         <category: 'smalltalk event'>
 
-        ^widget treeView hasSelectedValue
+        ^ widget hasSelection
     ]
 
     selectedValue [
         <category: 'smalltalk event'>
 
-        ^widget treeView selection
+        ^ widget selection
     ]
 
     inspectIt: anObject [
@@ -105,10 +102,10 @@ GtkConcreteWidget subclass: GtkVariableTrackerWidget [
 	<category: 'event'>
 
 	| ivar |
-	widget treeView hasSelectedValue ifFalse: [ ^ self ].
+	widget hasSelection ifFalse: [ ^ self ].
 	ivar := self selectedValue.
-	model remove: ivar.
 	object class removeInstVarName: ivar.
+        widget refresh
     ]
 ]
 
diff --git a/packages/visualgst/GtkVisualGSTTool.st b/packages/visualgst/GtkVisualGSTTool.st
index fa85181..17c6e5f 100644
--- a/packages/visualgst/GtkVisualGSTTool.st
+++ b/packages/visualgst/GtkVisualGSTTool.st
@@ -33,7 +33,7 @@
 |
 ======================================================================"
 
-GtkMainWindow subclass: GtkVisualGSTTool [
+Window subclass: GtkVisualGSTTool [
     <comment: 'I am the base for various tools of VisualGST.'>
 
     GtkVisualGSTTool class >> version [
diff --git a/packages/visualgst/GtkWorkspaceWidget.st b/packages/visualgst/GtkWorkspaceWidget.st
index fa55a3f..6729eca 100644
--- a/packages/visualgst/GtkWorkspaceWidget.st
+++ b/packages/visualgst/GtkWorkspaceWidget.st
@@ -58,10 +58,13 @@ GtkTextWidget subclass: GtkWorkspaceWidget [
     buildWidget [
         <category: 'user interface'>
 
-        ^ (GTK.GtkHPaned new)
-		    add1: (variableWidget := GtkVariableTrackerWidget on: object) mainWidget;
-		    add2: super buildWidget;
-                    yourself
+        | root |
+        super buildWidget.
+        root := child.
+        child := GTK.GtkHPaned new.
+        child
+	    add1: (variableWidget := GtkVariableTrackerWidget on: object) mainWidget;
+	    add2: root
     ]
 
     object: anObject [
@@ -120,7 +123,7 @@ GtkTextWidget subclass: GtkWorkspaceWidget [
     showIVar [
 	<category: 'smalltalk event'>
 
-	variableWidget mainWidget getVisible 
+	variableWidget isVisible
 		ifFalse: [ variableWidget showAll ]
 		ifTrue: [ variableWidget hideAll ].
     ]
diff --git a/packages/visualgst/Image/GtkImageWidget.st b/packages/visualgst/Image/GtkImageWidget.st
index 506752d..15c8782 100644
--- a/packages/visualgst/Image/GtkImageWidget.st
+++ b/packages/visualgst/Image/GtkImageWidget.st
@@ -33,55 +33,50 @@
 |
 ======================================================================"
 
-GtkConcreteWidget subclass: GtkImageWidget [
-
-    | imageTree image model searchEntry |
+Compoment subclass: GtkImageWidget [
 
+    | imageTree image searchEntry |
 
     initialize [
 	<category: 'initialization'>
 
-	self mainWidget: self buildMainWidget
+	self buildMainWidget
     ]
 
     buildMainWidget [
         <category: 'user interface'>
 
-        ^ GTK.GtkVPaned new
-            add1: self buildFinderEntry;
-            add2: self buildClassAndMethodList;
-            yourself
+        self widget: 
+            (VBox new
+                add: self buildFinderEntry;
+                add: self buildClassAndMethodList expand: true)
     ]
 
     buildFinderEntry [
         <category: 'user interface'>
 
-        searchEntry := GTK.GtkEntry new
-			    connectSignal: 'activate' to: self selector: #searchValidate;
+        searchEntry := Entry new
+			    whenTextChangedSend: #searchValidate to: self;
 			    yourself.
-        ^ (GTK.GtkHBox new: true spacing: 3)
-            add: (GTK.GtkLabel new: 'Class or method :');
-            add: searchEntry;
-            yourself
+        ^ HBox new
+            add: (Label text: 'Class or method :');
+            add: searchEntry expand: true
     ]
 
     buildClassAndMethodList [
         <category: 'user interface'>
 
-        imageTree := (GTK.GtkTreeView createListWithModel: {{GtkColumnTextType title: 'Methods and Classes'}}).
-        imageTree setSearchEntry: searchEntry.
-        [ (model := GtkListModel on: imageTree getModel)
-					item: (image := GtkImage new);
-                                        contentsBlock: [ :each | {each displayString} ];
-					refresh ] fork.
-        ^ GTK.GtkScrolledWindow withChild: imageTree
+        imageTree := List column: {{GtkColumnTextType title: 'Methods and Classes'}} contents: [ :each | {each displayString} ].
+        [ imageTree
+            item: (image := GtkImage new);
+            refresh ] fork.
+        ^ imageTree
     ]
 
     whenSelectionChangedSend: aSelector to: anObject [
         <category: 'events'>
 
-        imageTree getSelection
-            connectSignal: 'changed' to: anObject selector: aSelector
+        imageTree whenSelectionChangedSend: aSelector to: anObject
     ]
 
     whenTextChangedSend: aSelector to: anObject [
@@ -99,22 +94,22 @@ GtkConcreteWidget subclass: GtkImageWidget [
     text [
 	<category: 'accessing'>
 
-	^ searchEntry getText
+	^ searchEntry text
     ]
 
     searchValidate [
 	<category: 'search entry events'>
 
-	searchEntry getText isEmpty 
-		    ifTrue: [ model item: image ]
-		    ifFalse: [ model item: (image matchRegex: searchEntry getText) ].
-	model refresh
+	searchEntry text isEmpty 
+		    ifTrue: [ imageTree item: image ]
+		    ifFalse: [ imageTree item: (image matchRegex: searchEntry text) ].
+	imageTree refresh
     ]
 
     hasSelection [
 	<category: 'accessing'>
 
-	^ imageTree hasSelectedItem
+	^ imageTree hasSelection
     ]
 
     selection [
diff --git a/packages/visualgst/Implementors/GtkImageResultsWidget.st b/packages/visualgst/Implementors/GtkImageResultsWidget.st
index 986904c..c8ac273 100644
--- a/packages/visualgst/Implementors/GtkImageResultsWidget.st
+++ b/packages/visualgst/Implementors/GtkImageResultsWidget.st
@@ -33,49 +33,46 @@
 |
 ======================================================================"
 
-GtkConcreteWidget subclass: GtkImageResultsWidget [
-    | result resultTree model |
+Compoment subclass: GtkImageResultsWidget [
+
+    | result |
 
     initialize [
         <category: 'initialization'>
 
-        self mainWidget: self buildTreeView
+        self buildTreeView
     ]
 
     buildTreeView [
         <category: 'user interface'>
 
-        resultTree := GTK.GtkTreeView createListWithModel: {{GtkColumnTextType title: 'Methods and Classes'}}.
-        resultTree getSelection setMode: GTK.Gtk gtkSelectionBrowse.
-        (model := GtkListModel on: resultTree getModel)
-                                        contentsBlock: [ :each | {each asString} ].
-        ^ GTK.GtkScrolledWindow withChild: resultTree
+        self widget: (List column: {{GtkColumnTextType title: 'Methods and Classes'}} contents: [ :each | {each asString} ]).
+        widget singleSelection.
     ]
 
     whenSelectionChangedSend: aSelector to: anObject [
         <category: 'events'>
 
-        resultTree getSelection
-            connectSignal: 'changed' to: anObject selector: aSelector
+        widget whenSelectionChangedSend: aSelector to: anObject
     ]
 
     clear [
         <category: 'accessing'>
 
-        model clear
+        widget clear
     ]
 
     hasSelectedResult [
         <category: 'testing'>
 
-        ^ resultTree hasSelectedItem
+        ^ widget hasSelection
     ]
 
     selectedResult [
         <category: 'accessing'>
 
         self hasSelectedResult ifFalse: [ ^ self error: 'nothing is selected' ].
-        ^ resultTree selection
+        ^ widget selection
     ]
 
     appendResults: aDictionary [
diff --git a/packages/visualgst/Implementors/GtkImplementorResultsWidget.st b/packages/visualgst/Implementors/GtkImplementorResultsWidget.st
index dfc3883..8f1cd39 100644
--- a/packages/visualgst/Implementors/GtkImplementorResultsWidget.st
+++ b/packages/visualgst/Implementors/GtkImplementorResultsWidget.st
@@ -38,16 +38,16 @@ GtkImageResultsWidget subclass: GtkImplementorResultsWidget [
     buildTreeView [
         <category: 'user interface'>
 
-	| widget |
-	widget := super buildTreeView.
-	model contentsBlock: [ :each | {each key asString} ].
-	^ widget
+	super buildTreeView.
+	widget contents: [ :each | {each key asString} ].
     ]
 
     appendImplementorResults: aDictionary [
 
 	self clear.
-	aDictionary associationsDo: [ :each | model append: each ]
+	widget
+            item: aDictionary associations;
+            refresh
     ]
 
     selectedResult: aBrowser [
@@ -55,6 +55,5 @@ GtkImageResultsWidget subclass: GtkImplementorResultsWidget [
         self hasSelectedResult ifFalse: [ ^ self ].
         self selectedResult value updateBrowser: aBrowser 
     ]
-
 ]
 
